<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – PHP Script Server</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="php-script-server">PHP Script Server</h1>
<p>The <strong>PHP Script Server</strong> is a memory resident PHP interpreter that is launched by each Cacti <strong>Data Collector</strong> or poller each polling cycle. If using <code>cmd.php</code>, there will be at most one <strong>PHP Script Server</strong> launched per poller process. If using <code>spine</code> poller, then up to 10 <strong>PHP Script Servers</strong> will be launched in a pool for the various <code>spine</code> threads to consume.</p>
<p>If you have a number of devices that must gather their data via a script, it's very important to utilize the <strong>PHP Script Server</strong>. This feature allows for the rapid execution of PHP based <strong>Scripts</strong> and <strong>Data Queries</strong> in Cacti thus reducing <strong>Data Collector</strong> polling times.</p>
<p>The reason that the <strong>PHP Script Server</strong> is so fast is that the PHP interpreter is started in memory one time, and for every <strong>Data Source</strong> polled, it's controlling function is interpreted only once. The resulting much faster script execution and reduced load average during the <strong>Data Collectors</strong> life cycle. Using the <strong>PHP Script Server</strong> process over the traditional exec() process nets roughly a 20+ fold speed improvement in Cacti's <strong>Data Collection</strong> process.</p>
<p>Since PHP is such a powerful language, this Cacti feature enables rapid collection of virtually any <strong>Data Source</strong> metric. It's an excellent choice for both SNMP and non-SNMP based data.</p>
<h2 id="using-the-script-server">Using the Script Server</h2>
<p>Cacti contains two sample <strong>PHP Script Server</strong> scripts for reference. They are for the collection of HostMib CPU and Disk Partition information. These two examples are based off the traditional POPEN version of the HostMib functions found in earlier versions of Cacti. Upgrading from these very old <strong>Data Input Methods</strong> to the <strong>PHP Script Server</strong> is not longer supported.</p>
<h2 id="migration-of-existing-scripts-and-data-queries-to-php-script-server">Migration of Existing Scripts and Data Queries to PHP Script Server</h2>
<p>If you have <strong>Scripts</strong> or <strong>Data Queries</strong> that you wish to migrate, you must follow the steps below to migrate those scripts to the <strong>PHP Script Server</strong> format.</p>
<h3 id="script-file-changes">Script File Changes</h3>
<p>First, if your script is written in another languages, say Perl, or Python, you need to convert it to PHP. Then, each PHP Script file must be changed to the new Script Server format. The changes are not dramatic, but required for the proper operation of the <strong>PHP Script Server</strong>. Note that you should use PHP internal functions for calling services rather than forking binaries within the PHP script as this will defeat the purpose of the <strong>PHP Script Server</strong>. Follow the steps below to complete the migration.</p>
<ol>
<li><p>Copy your existing script to a new name. The name must begin <code>ss_</code> followed by your script name. The <code>ss_</code> identifies the script as being a script server variety of the a PHP script and is named that way to easily identify them in your install. For example, if you previously had a script called <code>get_mysql_stats.php</code>, it's new name would be <code>ss_get_mysql_stats.php</code>.</p></li>
<li><p>Edit the new PHP script and add the following required lines to the file, where <code>ss_myfunction</code> is the same as your filename.</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">&lt;?php</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="kw">$no_http_headers</span> = <span class="kw">true</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb1-3" title="3"></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="co">/* display No errors */</span></a>
<a class="sourceLine" id="cb1-5" title="5"><span class="fu">error_reporting</span><span class="ot">(</span><span class="kw">E_ERROR</span><span class="ot">);</span></a>
<a class="sourceLine" id="cb1-6" title="6"></a>
<a class="sourceLine" id="cb1-7" title="7"><span class="kw">if</span> <span class="ot">(</span>!<span class="kw">isset</span><span class="ot">(</span><span class="kw">$called_by_script_server</span><span class="ot">))</span> {</a>
<a class="sourceLine" id="cb1-8" title="8">    <span class="fu">array_shift</span><span class="ot">(</span><span class="kw">$_SERVER</span><span class="ot">[</span><span class="st">&quot;argv&quot;</span><span class="ot">]);</span></a>
<a class="sourceLine" id="cb1-9" title="9">    <span class="kw">print</span> <span class="fu">call_user_func_array</span><span class="ot">(</span><span class="st">&quot;ss_myfunction&quot;</span><span class="ot">,</span> <span class="kw">$_SERVER</span><span class="ot">[</span><span class="st">&quot;argv&quot;</span><span class="ot">]);</span></a>
<a class="sourceLine" id="cb1-10" title="10">}</a>
<a class="sourceLine" id="cb1-11" title="11"><span class="kw">?&gt;</span></a></code></pre></div></li>
<li><p>What was originally just mainline code, must be replaced with a function name. For example, if your program previously contained the following three lines of code:</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">&lt;?php</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="kw">$a</span> = <span class="dv">100</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="kw">$b</span> = <span class="kw">$a</span> / <span class="dv">10</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb2-4" title="4"><span class="kw">print</span> <span class="kw">$b</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb2-5" title="5"><span class="kw">?&gt;</span></a></code></pre></div>
<p>Would become:</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">function</span> ss_myfunction<span class="ot">()</span> {</a>
<a class="sourceLine" id="cb3-2" title="2">    <span class="kw">$a</span> = <span class="dv">100</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb3-3" title="3">    <span class="kw">$b</span> = <span class="kw">$a</span> / <span class="dv">10</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb3-4" title="4">    <span class="kw">print</span> <span class="kw">$b</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb3-5" title="5">}</a></code></pre></div></li>
<li><p>If you have any additional functions declared within your script file, you must prefix them to make them unique among all functions. Our recommendation would be to prefix all functions with the name of the main function. For example if you have a function called "meme" you would rename it to <code>ss_myfunction_meme</code>. This guarantee's correct <strong>PHP Script Server</strong> functionality.</p></li>
<li><p>The last step is to change the function call that could have traditionally returned the value to the Cacti poller using the <code>print</code> function. You must change that line or lines in your code to utilize the <code>return</code> function instead. However, this does not apply to <code>print</code> statements that are not called from the Poller. For a simple script, this results in</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">function</span> ss_myfunction<span class="ot">()</span> {</a>
<a class="sourceLine" id="cb4-2" title="2">    <span class="kw">$a</span> = <span class="dv">100</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb4-3" title="3">    <span class="kw">$b</span> = <span class="kw">$a</span> / <span class="dv">10</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb4-4" title="4">    <span class="kw">return</span> <span class="kw">$b</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb4-5" title="5">}</a></code></pre></div>
<p>Be careful, when writing Script Server Data Queries. Use the <code>return</code> function for returning results of the GET operation. But use <code>print</code> for <code>index</code> and <code>query</code> operations, e.g.</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">if</span> <span class="ot">((</span><span class="kw">$cmd</span> == <span class="st">&quot;index&quot;</span><span class="ot">))</span> {</a>
<a class="sourceLine" id="cb5-2" title="2">    <span class="st">...</span></a>
<a class="sourceLine" id="cb5-3" title="3">    <span class="kw">print</span> <span class="kw">$some_index_data</span> . <span class="kw">PHP_EOL</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb5-4" title="4">} <span class="kw">elseif</span> <span class="ot">(</span><span class="kw">$cmd</span> == <span class="st">&quot;query&quot;</span><span class="ot">)</span> {</a>
<a class="sourceLine" id="cb5-5" title="5">    <span class="st">...</span></a>
<a class="sourceLine" id="cb5-6" title="6">    <span class="kw">print</span> <span class="kw">$some_query_data</span> . <span class="kw">PHP_EOL</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb5-7" title="7">} <span class="kw">elseif</span> <span class="ot">(</span><span class="kw">$cmd</span> == <span class="st">&quot;get&quot;</span><span class="ot">)</span> {</a>
<a class="sourceLine" id="cb5-8" title="8">    <span class="st">...</span></a>
<a class="sourceLine" id="cb5-9" title="9">    <span class="kw">return</span> <span class="kw">$some_get_data</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb5-10" title="10">}</a></code></pre></div></li>
</ol>
<h3 id="xml-file-changes">XML File Changes</h3>
<p>If your <strong>Data Sources</strong> are based upon a <strong>Data Query</strong>, then you must also change your XML file contents and location. Please reference the XML files in the <code>&lt;path_cacti&gt;/resource/script_server</code> directory for the specifics related to your required modifications. However, you may also follow the instructions below:</p>
<ol>
<li><p>Modify the <code>&lt;script_path&gt;</code> tag. Change it from:</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode xml"><code class="sourceCode xml"><a class="sourceLine" id="cb6-1" title="1"><span class="kw">&lt;script_path&gt;</span>|path_php_binary| -q |path_cacti|/scripts/myfucntion.php<span class="kw">&lt;/script_path&gt;</span></a></code></pre></div>
<p>to simply the following:</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode xml"><code class="sourceCode xml"><a class="sourceLine" id="cb7-1" title="1"><span class="kw">&lt;script_path&gt;</span>|path_cacti|/scripts/ss_myfunction.php<span class="kw">&lt;/script_path&gt;</span></a></code></pre></div></li>
<li><p>Add the following two XML tags below the <code>&lt;script_path&gt;</code> tag. Replace <code>ss_myfunction</code> with your function name:</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode xml"><code class="sourceCode xml"><a class="sourceLine" id="cb8-1" title="1"><span class="kw">&lt;script_function&gt;</span>ss_myfunction<span class="kw">&lt;/script_function&gt;</span></a>
<a class="sourceLine" id="cb8-2" title="2"><span class="kw">&lt;script_server&gt;</span>php<span class="kw">&lt;/script_server&gt;</span></a></code></pre></div></li>
<li><p>Save the XML file.</p></li>
</ol>
<h3 id="data-query--data-template-changes">Data Query &amp; Data Template Changes</h3>
<p>Your <strong>Data Queries</strong> and <strong>Data Templates</strong> must be also modified. Although somewhat self explanatory by now, you must make the following changes:</p>
<ol>
<li><p>If the <strong>Data Template</strong> is based upon a <strong>Script</strong> and not a <strong>Data Query</strong>, change it's <strong>Data Input Method</strong> to <code>Script Server</code>.</p></li>
<li><p>If the <strong>Data Template</strong> is based upon a <strong>Data Query</strong>, edit the <strong>Data Query</strong> and change it's <strong>Data Input Method</strong> to <code>Get Script Server Data (Indexed)</code> and change the XML file path to point to the new XML file in the <code>&lt;path_cacti&gt;/resources/script_server/</code> directory.</p></li>
<li><p>Your final step is to go to the <strong>Console &gt; System Utilities &gt; Rebuild Poller Cache</strong> to apply the new settings.</p></li>
</ol>
<p>If your <strong>PHP Script Server</strong> script is operating correctly, you should now be migrated to the <strong>PHP Script Server</strong>.</p>
<h2 id="testing-your-script-in-the-script-server">Testing Your Script in the Script Server</h2>
<p>To test your script in the script server, simply follow the instructions below. When you have finished you testing, simply type "quit" + <code>&lt;CR&gt;</code> at the <strong>PHP Script Server</strong> command line to exit the script server.</p>
<ol>
<li><p>Start the script server - You can do this by typing the following command:</p>
<pre class="console"><code>shell&gt; php &lt;path_cacti&gt;/script_server.php
</code></pre>
<blockquote>
<p><strong>NOTE</strong>: Due to a bug in Windows implementation of PHP, you must type the full path name to the <code>script_server.php</code> file.</p>
</blockquote></li>
<li><p>Type in your command - Using the example from above, you would type in the following:</p>
<div class="sourceCode" id="cb10"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb10-1" title="1"><span class="ex">script</span> server<span class="op">&gt;</span> /path_cacti/scripts/ss_myserver_file.php my_function argument1 argument2 ...</a></code></pre></div>
<p>In the Windows environment, your example could be the following:</p>
<div class="sourceCode" id="cb11"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb11-1" title="1"><span class="ex">script</span> server<span class="op">&gt;</span> c:\www\root\cacti\script\ss_myserver_file.php ss_myfunction argument1 argument2 ...</a></code></pre></div></li>
<li><p>If your script and function is operating properly, you should get a result.</p>
<div class="sourceCode" id="cb12"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb12-1" title="1"><span class="ex">script</span> server<span class="op">&gt;</span> c:\www\root\cacti\script\ss_myserver_file.php ss_myfunction argument1 argument2 ...</a>
<a class="sourceLine" id="cb12-2" title="2"><span class="ex">nameA</span>:valueA nameB:valueB ...</a></code></pre></div></li>
<li><p>To quit the script server, simply type <code>quit &lt;CR&gt;</code> at the command line.</p>
<blockquote>
<p><strong>Note</strong>: If there are errors in your script, you must restart the script server before your retest your code.</p>
</blockquote></li>
</ol>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
